package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class InstructorTest {
    Teacher teacher = new Instructor(87);
    Instructor instructor = new Instructor(555);
    Person instructor2 = new Instructor(139);
    Learner learner = new Student(9);

    @Test
    public void testImplementation(){
        Assert.assertTrue(instructor.getClass().isInstance(teacher));
    }

    @Test
    public void testInheritance(){
        Assert.assertTrue((instructor.getClass().isInstance(instructor2)));
    }

    @Test
    public void testTeach(){
        Student student = new Student(333333);

        instructor.teach(student, 543);
        double actual = student.getTotalStudytime();
        double expected = 543;

        Assert.assertTrue(expected == actual);
    }

    @Test
    public void testLecture(){
        Student student = new Student(7575);
        Student student1 = new Student(129);
        Student student2 = new Student(8884);

        Student[] students = {student, student1, student2};
        instructor.lecture(students, 4848);

        students[0].learn(4848/students.length);
        students[1].learn(4848/students.length);
        students[2].learn(4848/students.length);


        Assert.assertTrue(students[0].getTotalStudytime() == students[1].getTotalStudytime() && students[0].getTotalStudytime() == students[2].getTotalStudytime());
//        Assert.assertTrue(4848/students.length == students[0].getTotalStudytime());
    }
}
